VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "msflxgrd.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2430
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   13230
   LinkTopic       =   "Form1"
   ScaleHeight     =   2430
   ScaleWidth      =   13230
   StartUpPosition =   3  'Windows Default
   Begin MSFlexGridLib.MSFlexGrid flxPrinters 
      Height          =   1335
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3855
      _ExtentX        =   6800
      _ExtentY        =   2355
      _Version        =   393216
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function OpenPrinter Lib "winspool.drv" Alias "OpenPrinterA" (ByVal pPrinterName As String, phPrinter As Long, pDefault As Long) As Long
Private Declare Function ClosePrinter Lib "winspool.drv" (ByVal hPrinter As Long) As Long
Private Declare Function GetPrinterDriver Lib "winspool.drv" Alias "GetPrinterDriverA" (ByVal hPrinter As Long, ByVal pEnvironment As String, ByVal Level As Long, pDriverInfo As Long, ByVal cdBuf As Long, pcbNeeded As Long) As Long
Private Type DRIVER_INFO_2
    cVersion As Long
    pName As String
    pEnvironment As String
    pDriverPath As String
    pDataFile As String
    pConfigFile As String
End Type

Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Long) As Long
Private Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (ByVal lpString1 As Long, ByVal lpString2 As String) As Long
Private Declare Function lstrcpyToBuffer Lib "kernel32" Alias "lstrcpyA" (ByVal lpString1 As String, ByVal lpString2 As Long) As Long
Private Declare Function IsBadStringPtrByLong Lib "kernel32" Alias "IsBadStringPtrA" (ByVal lpsz As Long, ByVal ucchMax As Long) As Long
' Make the columns fit their data.
Private Sub AutoFitFlexGrid(ByVal flx As MSFlexGrid)
Dim R As Long
Dim C As Long
Dim cell_wid As Single
Dim col_wid As Single

    For C = 0 To flx.Cols - 1
        col_wid = 0
        For R = 0 To flx.Rows - 1
            cell_wid = TextWidth(flx.TextMatrix(R, C))
            If col_wid < cell_wid Then col_wid = cell_wid
        Next R
        flx.ColWidth(C) = col_wid + 120
    Next C
End Sub

' Return True if the printer is a PostScript printer.
Private Function GetDriverInfo2(ByVal printer_name As String) As DRIVER_INFO_2
Dim h_printer As Long
Dim buf_len As Long
Dim buf() As Long
Dim driver_info As DRIVER_INFO_2

    ' Get the printer's handle.
    If OpenPrinter(printer_name, h_printer, ByVal 0&) = 0 Then
        MsgBox "Error opening printer " & printer_name & "." & vbCrLf & _
            Err.Description
        GetDriverInfo2 = driver_info
        Exit Function
    Else
        ' See how much space we need for the
        ' driver info structure with its strings.
        ReDim buf(1 To 1)
        GetPrinterDriver h_printer, "", 2, _
            buf(1), 0, buf_len

        ' Get the data.
        ReDim buf(1 To buf_len / 4 + 1)
        If GetPrinterDriver(h_printer, "", 2, _
            buf(1), buf_len, buf_len) = 0 _
        Then
            MsgBox "Error getting driver information for " & printer_name & "." & vbCrLf & _
                Err.Description
            GetDriverInfo2 = driver_info
            ClosePrinter h_printer
            Exit Function
        End If

        ' Get the information.
        driver_info.cVersion = buf(1)
        driver_info.pName = StringFromPointer(buf(2), 1024)
        driver_info.pEnvironment = StringFromPointer(buf(3), 1024)
        driver_info.pDriverPath = StringFromPointer(buf(4), 1024)
        driver_info.pDataFile = StringFromPointer(buf(5), 1024)
        driver_info.pConfigFile = StringFromPointer(buf(6), 1024)

        GetDriverInfo2 = driver_info

        ClosePrinter h_printer
    End If
End Function


Public Function StringFromPointer(lpString As Long, lMaxLength As Long) As String
    ' Returns a VB string from an API returned string pointer
    ' Parameters:
    '   lpString - The long pointer to the string
    '   lMaxlength - the size of empty buffer to allow
    ' HISTORY:
    '   JS 22/11/2002 Check pointer is a valid string pointer...

    Dim sRet As String
    Dim lret As Long
    
    If lpString = 0 Then
        StringFromPointer = ""
        Exit Function
    End If
    
    lret = lstrlen(lpString)
    If lret < lMaxLength Then
        lMaxLength = lret
    End If
    
    If IsBadStringPtrByLong(lpString, lMaxLength) Then
        ' An error has occured - do not attempt to use this pointer
       ' Call ReportError(Err.LastDllError, "StringFromPointer", "Attempt to read bad string pointer: " & lpString)
        StringFromPointer = ""
        Exit Function
    End If
    
    ' Pre-initialise the return string...
    sRet = Space$(lMaxLength)
    Call lstrcpyToBuffer(sRet, lpString)
    'CopyMemory ByVal sRet, ByVal lpString, ByVal Len(sRet)
    If Err.LastDllError = 0 Then
        If InStr(sRet, Chr$(0)) > 0 Then
            sRet = Left$(sRet, InStr(sRet, Chr$(0)) - 1)
        End If
    End If

    StringFromPointer = sRet
End Function
Private Sub Form_Load()
Dim driver_info As DRIVER_INFO_2
Dim i As Long
Dim txt As String

    ' Prepare the FlexGrid.
    flxPrinters.Cols = 6
    flxPrinters.Rows = Printers.Count + 1
    flxPrinters.TextMatrix(0, 0) = "Version"
    flxPrinters.TextMatrix(0, 1) = "Name"
    flxPrinters.TextMatrix(0, 2) = "Environment"
    flxPrinters.TextMatrix(0, 3) = "Driver Path"
    flxPrinters.TextMatrix(0, 4) = "Data File"
    flxPrinters.TextMatrix(0, 5) = "Config File"
    flxPrinters.Row = 0
    For i = 0 To 5
        flxPrinters.Col = i
        flxPrinters.CellFontBold = True
        flxPrinters.ColWidth(i) = 1440
    Next i
    flxPrinters.FixedCols = 0
    flxPrinters.AllowUserResizing = flexResizeColumns

    ' Get printer information.
    For i = 0 To Printers.Count - 1
        ' Get the printer's information.
        driver_info = GetDriverInfo2(Printers(i).DeviceName)

        ' Display the printer's information.
        flxPrinters.TextMatrix(i + 1, 0) = driver_info.cVersion
        flxPrinters.TextMatrix(i + 1, 1) = driver_info.pName
        flxPrinters.TextMatrix(i + 1, 2) = driver_info.pEnvironment
        flxPrinters.TextMatrix(i + 1, 3) = driver_info.pDriverPath
        flxPrinters.TextMatrix(i + 1, 4) = driver_info.pDataFile
        flxPrinters.TextMatrix(i + 1, 5) = driver_info.pConfigFile
    Next i

    ' Make the columns fit the data.
    AutoFitFlexGrid flxPrinters
End Sub
Private Sub Form_Resize()
    flxPrinters.Move 0, 0, ScaleWidth, ScaleHeight
End Sub


