VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPPDUIFeature"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_GroupName As String
Private m_TranslationName As String
Private m_GroupType As String
Private m_QueryStream As String

Private m_OrderDependency As CPPDOrderDependency
Private m_DefaultChoice As CPPDUIChoice
Private m_CurrentChoice As CPPDUIChoice
Private m_Choices As CPPDUIChoicesObj

Friend Property Get GroupName() As String
    GroupName = m_GroupName
End Property

Friend Property Let TranslationName(ByVal vNewValue As String)
    m_TranslationName = vNewValue
End Property

Friend Property Get TranslationName() As String
    TranslationName = m_TranslationName
End Property

Friend Property Let GroupType(ByVal vNewValue As String)
    m_GroupType = vNewValue
End Property

Friend Property Get GroupType() As String
    GroupType = m_GroupType
End Property

Friend Property Let QueryStream(ByVal vNewValue As String)
    m_QueryStream = vNewValue
End Property

Friend Property Get QueryStream() As String
    QueryStream = m_QueryStream
End Property

Friend Property Set OrderDependency(ByVal vNewValue As CPPDOrderDependency)
    Set m_OrderDependency = vNewValue
End Property

Friend Property Get OrderDependency() As CPPDOrderDependency
    Set OrderDependency = m_OrderDependency
End Property

Friend Property Set DefaultChoice(ByVal vNewValue As CPPDUIChoice)
    Set m_DefaultChoice = vNewValue
End Property

Friend Property Get DefaultChoice() As CPPDUIChoice
    Set DefaultChoice = m_DefaultChoice
End Property

Public Property Set CurrentChoice(ByVal NewValue As CPPDUIChoice)
    Set m_CurrentChoice = NewValue
End Property
Public Property Get CurrentChoice() As CPPDUIChoice
    Set CurrentChoice = m_CurrentChoice
End Property

Friend Property Set Choices(ByVal vNewValue As CPPDUIChoicesObj)
    Set m_Choices = vNewValue
End Property

Friend Property Get Choices() As CPPDUIChoicesObj
    Set Choices = m_Choices
End Property

Friend Function InitGroup(ByVal vGroupNameString As String) As Boolean
    Dim lpos&
    lpos = InStr(vGroupNameString, "/")
    If (lpos > 0) Then
        m_GroupName = Mid(vGroupNameString, 1, lpos - 1)
        m_TranslationName = Mid(vGroupNameString, lpos + 1)
    Else
        m_GroupName = vGroupNameString
        m_TranslationName = vGroupNameString
    End If
    InitGroup = True
End Function

Friend Function InitOrderDependency(vDependencyString As String) As Boolean
    '
    ' Initialises the variables in the m_OrderDependency object
    Dim DependencySetup() As String
    
    DependencySetup() = Split(vDependencyString, " ")
    m_OrderDependency.RankingValue = DependencySetup(0)
    m_OrderDependency.Section = DependencySetup(1)
    m_OrderDependency.MainKeyword = DependencySetup(2)
    If UBound(DependencySetup()) = 3 Then
        m_OrderDependency.OptionKeyword = DependencySetup(3)
    End If

    InitOrderDependency = True

End Function

Private Sub Class_Initialize()
    
    Set m_Choices = New CPPDUIChoicesObj
    Set m_OrderDependency = New CPPDOrderDependency
    
End Sub

Private Sub Class_Terminate()

    Set m_CurrentChoice = Nothing
    Set m_DefaultChoice = Nothing
    Set m_Choices = Nothing
    Set m_OrderDependency = Nothing

End Sub
